From 3156c6ff9eebdc41dde90171749149eddfc66291 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Wed, 7 Dec 2011 14:18:25 -0600
Subject: Grade library now supports manual rawgrade

---
 grade/edit/tree/item_form.php |    5 -----
 grade/report/grader/lib.php   |    5 +++++
 lib/grade/grade_item.php      |   14 +++++++++-----
 3 files changed, 14 insertions(+), 10 deletions(-)

diff --git a/grade/edit/tree/item_form.php b/grade/edit/tree/item_form.php
index 642be6b..412b206 100644
--- a/grade/edit/tree/item_form.php
+++ b/grade/edit/tree/item_form.php
@@ -281,11 +281,6 @@ class edit_item_form extends moodleform {
                     }
                 }
             }
-
-        } else {
-            // all new items are manual, children of course category
-            $mform->removeElement('plusfactor');
-            $mform->removeElement('multfactor');
         }
 
         // no parent header for course category
diff --git a/grade/report/grader/lib.php b/grade/report/grader/lib.php
index bcacf6d..360c7d3 100644
--- a/grade/report/grader/lib.php
+++ b/grade/report/grader/lib.php
@@ -926,6 +926,11 @@ class grade_report_grader extends grade_report {
 
                 } else if ($USER->gradeediting[$this->courseid]) {
 
+                    // Editing means user edit manual item raw
+                    if ($item->is_manual_item()) {
+                        $gradeval = $grade->rawgrade;
+                    }
+
                     if ($item->scaleid && !empty($scalesarray[$item->scaleid])) {
                         $scale = $scalesarray[$item->scaleid];
                         $gradeval = (int)$gradeval; // scales use only integers
diff --git a/lib/grade/grade_item.php b/lib/grade/grade_item.php
index 630e915..0e60942 100644
--- a/lib/grade/grade_item.php
+++ b/lib/grade/grade_item.php
@@ -655,10 +655,6 @@ class grade_item extends grade_object {
                 return "Could not aggregate final grades for category:".$this->id; // TODO: improve and localize
             }
 
-        } else if ($this->is_manual_item()) {
-            // manual items track only final grades, no raw grades
-            return true;
-
         } else if (!$this->is_raw_used()) {
             // hmm - raw grades are not used- nothing to regrade
             return true;
@@ -935,7 +931,7 @@ class grade_item extends grade_object {
      * @return boolean
      */
     public function is_raw_used() {
-        return ($this->is_external_item() and !$this->is_calculated() and !$this->is_outcome_item());
+        return ($this->is_manual_item() or $this->is_external_item() and !$this->is_calculated() and !$this->is_outcome_item());
     }
 
     /**
@@ -1438,6 +1434,14 @@ class grade_item extends grade_object {
             return false;
         }
 
+        // Manual Item raw-grade support
+        if ($this->is_manual_item()) {
+            return $this->update_raw_grade(
+                $userid, $finalgrade, $source, $feedback, $feedbackformat,
+                $usermodified, null, null, $grade
+            );
+        }
+
         $oldgrade = new stdClass();
         $oldgrade->finalgrade     = $grade->finalgrade;
         $oldgrade->overridden     = $grade->overridden;
-- 
1.7.1


